#include <stdio.h>
#include <string.h>
#include "mcu_init.h"
#include "config.h"
#include "device.h"
#include "spi2.h"
#include "socket.h"
#include "w5500.h"
#include "at24c16.h"
#include "util.h"
#include "ftpd.h"
#include <stdio.h>

#define FLASH_PAGE_SIZE    ((uint16_t)0x800)

extern uint16 sio_rd ;
extern uint16 sio_wr;
extern uint8 sio_buf[SIO_BUF_SIZE];

vu32 ms=0;
vu8 sec=0,min=0;
vu8 hour=0;

vs32 Filenum=0;

vu16 nagle=0;//unit: ms
vu16 inact=0;//uint: s
vu16 recon=0;//uint: ms

//extern uint8 DHCP_timer;
//extern uint32  dhcp_time;
//extern uint8 ip_setted;//dhcp 

extern uint8 txsize[];
extern uint8 rxsize[];
#define SOCK_TCPS       0
#define SOCK_UDPS       1
#define PORT_TCPS	5000
#define PORT_UDPS       3000
uint8 buffer[2048];/*һ2KBĻ*/
uint8 reboot_flag = 0;
uint8_t gFTPBUF[_MAX_SS];  
void main()
{ 
  uint8 ch[8];
  uint16 i;
  
  RCC_Configuration(); /* õƬϵͳʱ*/
  GPIO_Configuration();/* GPIO*/
  NVIC_Configuration();/* Ƕж*/
  
  Systick_Init(72);/* ʼSystickʱ*/
  USART1_Init(); /*ʼͨ:115200@8-n-1*/
  at24c16_init();/*ʼeeprom*/
  printf("W5500 EVB initialization over.\r\n");
  
  Reset_W5500();/*ӲW5500*/
  WIZ_SPI_Init();/*ʼSPIӿ*/
  printf("W5500 initialized!\r\n");  
  
  set_default();/*ʼò*/
  set_network();/**/

  printf("Network is ready!\r\n");
  #ifdef F_APP_FTP
  ftpd_init(ConfigMsg.lip);
  #endif
  
  //  Erase all page of 128K Bytes
  FLASH_Unlock();
  // Clear All pending flags
  FLASH_ClearFlag(FLASH_FLAG_BSY | FLASH_FLAG_EOP | FLASH_FLAG_PGERR | FLASH_FLAG_WRPRTERR);
  for(i=0;i<64;i++)
    FLASH_ErasePage( 0x08020000 + i*FLASH_PAGE_SIZE);
  FLASH_Lock();
  
  Filenum=-1;
  
  while(1)
  {  
    #ifdef F_APP_FTP
      ftpd_run(gFTPBUF);
    #endif 
     
    if(sio_wr>=80)    // ÿ80ֽڱһ
      {
        Filenum++;
        
        //Flash_Write( 0x08020000, sio_buf, 4 );
        //unlock flash
        FLASH_Unlock();
        // Clear All pending flags
        FLASH_ClearFlag(FLASH_FLAG_BSY | FLASH_FLAG_EOP | FLASH_FLAG_PGERR | FLASH_FLAG_WRPRTERR);
        
        if( (Filenum%25)==0)  // жǲÿһҳĵһʹãʱҳ
          FLASH_ErasePage( 0x08020000 + (Filenum/25)*FLASH_PAGE_SIZE);
        
        for(i=0;i<20;i++)
        {
          FLASH_ProgramWord( 0x08020000+(Filenum/25)*FLASH_PAGE_SIZE+(Filenum%25)*80+4*i,*( (u32 *)(sio_buf+4*i) ) ); 
          // (Filenum/25)*FLASH_PAGE_SIZE ҳַ
          // (Filenum%25)*80              ļַ        
        }
        FLASH_Lock();
        
        //ch[3]=(uint8)((*(vu32*)0x08020000+(Filenum/25)*FLASH_PAGE_SIZE+(Filenum%25)*80)>>24);
        //ch[2]=(uint8)((*(vu32*)0x08020000+(Filenum/25)*FLASH_PAGE_SIZE+(Filenum%25)*80)>>16);
        //ch[1]=(uint8)((*(vu32*)0x08020000+(Filenum/25)*FLASH_PAGE_SIZE+(Filenum%25)*80)>>8);
        //ch[0]=(uint8)((*(vu32*)0x08020000+(Filenum/25)*FLASH_PAGE_SIZE+(Filenum%25)*80));
        
        memcpy( ch, (void const *)(0x08020000+(Filenum/25)*FLASH_PAGE_SIZE+(Filenum%25)*80), 8);
        
        //for( i=0;i<3;i++ )
        //  USART_SendData(USART1, (uint8_t) ch[i]);
        printf("FileNo. %d:%x%x%x%x%x%x%x%x",Filenum,ch[0],ch[1],ch[2],ch[3],ch[4],ch[5],ch[6],ch[7]);
        
        sio_wr=0;
        
        
        if( Filenum>=3200 )
        {
          Filenum=0;
        }
        
      }  
      
  }
}

/**************************/
/*****Timer2 interrupt*****/
/**************************/
void Timer2_ISR(void)
{
 
  ms++;//mili second
  nagle++;
  recon++;
  
  if(ms>=1000)//second
  {  
    ms=0;
    sec++;
    inact++;
    /*ka_period++;*/
    //ka_interval++;
    //dhcp
    //if(DHCP_timer)dhcp_time++;
    //http timeout counter
    //if(http_time_flag) http_time_cnt++;
    
    //device working time in second
    //ConfigMsg.on_time++;

  }
  if(sec>=60)//minute
  {
    sec=0;
    min++;
  }
  if(min>=60)//hour
  {
    min=0;
    hour++;
  }
  if(hour>=24)//day
  {
    hour=0;
    //reboot_flag=1;
  }
}