#include <stdio.h>
//#include <stdlib.h>
#include <string.h>

#include "serial.h"
#include "config.h"
#include "util.h" //for led control
//extern CONFIG_MSG  ConfigMsg;

uint8 bsio_full = 0;
uint8 bflow_own = 0;
uint8 bflow_peer = 0;

uint8 sio_buf[SIO_BUF_SIZE];  
//
uint16 sio_rd = 0;
uint16 sio_wr = 0;

uint16 _kbhit(void)
{
   uint16 ret = 0;

   if(bsio_full==1) ret = SIO_BUF_SIZE;
   else if(sio_wr < sio_rd) ret = SIO_BUF_SIZE - sio_rd + sio_wr; 
   else ret = sio_wr - sio_rd;
   return ret;
}
void PutByte(uint8 ch, uint8 data)
{
  USART_TypeDef* USARTx;
  if (ch == 0) 
  {
    USARTx = USART1;
    USART_ClearFlag(USARTx, USART_FLAG_TC); //transmission complete
    (ConfigMsg.databit==DATABIT_7_INDEX) ? (USART_SendData(USARTx, (data | 0x80))) : (USART_SendData(USARTx, data));
  }
  else if (ch ==1) 
  {
    USARTx = USART2;
  
    USART_ClearFlag(USARTx, USART_FLAG_TC); //transmission complete
    (ConfigMsg.databit==DATABIT_7_INDEX) ? (USART_SendData(USARTx, (data | 0x80))) : (USART_SendData(USARTx, data));
   
  }
  while(USART_GetFlagStatus(USARTx, USART_FLAG_TXE) == RESET) // Tx buffer empty
  {   
  }
  //
  while(USART_GetFlagStatus(USARTx, USART_FLAG_TC) == RESET); //?
  USART_ClearFlag(USARTx, USART_FLAG_TC);
}
int8 _getkey ()  //reentrant
{
   int8 ret = 0;

   while(bsio_full !=1 && sio_rd==sio_wr);
   ret = sio_buf[sio_rd];
   sio_rd++;
   if(sio_rd == SIO_BUF_SIZE) sio_rd=0;
   bsio_full = 0;
   return ret;
}
uint16 uart_gets(uint8* buf, uint16 max)
{
   uint16 i;
   for(i=0; i < max && _kbhit(); i++) buf[i] = _getkey();
   return i;
}

void uart_flush(void)
{
  sio_rd=0;
  sio_wr=0;
  bsio_full=0;
}

void json_serial_data(int8 *buf)
{
  sprintf(buf,"getRs232DataCallback({\"data\":\"%s\"});", sio_buf);
  uart_flush();
  memset(sio_buf,0x00,SIO_BUF_SIZE);
}